worker_processes  4; # Mind this number...no more than 2 workers per core.

events {
  worker_connections  19000;
}

worker_rlimit_nofile 20000;

http {
  include /etc/nginx/mime.types;
  default_type  application/octet-stream;
  client_max_body_size 2048M;

  sendfile        on;
  keepalive_timeout  65;

  gzip on;
  gzip_comp_level 1;
  gzip_min_length 1000;
  gzip_types  text/plain application/javascript application/x-javascript text/javascript text/xml text/css ;

  # Add a vary header for downstream proxies to avoid sending cached gzipped files to IE6
  gzip_vary on;

  proxy_no_cache 1;
  proxy_set_header X-Real-IP $remote_addr;
  proxy_set_header Host $host;
  proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
  proxy_set_header X-NginX-Proxy true;
  proxy_http_version 1.1;
  proxy_read_timeout 1200s;
  # Proxy buffering must be turned off...
  proxy_request_buffering off;
  proxy_buffering off;
  proxy_redirect off;

  server {
    listen       80;
    server_name  localhost;

    # For the geeks: "A man is not dead while his name is still spoken." -Terry Pratchett
    add_header X-Clacks-Overhead "GNU Terry Pratchett";

    location /service_auth {
      proxy_pass http://auth:7070/service_auth;
    }

    location /api/auth/service/auth/ {
      proxy_pass http://auth:7070/service_auth/service/auth/;
    }

    location /api/auth/rest/ {
      proxy_pass http://auth:7070/service_auth/rest/;
    }

    location /api/geolocation/ {
      proxy_pass http://backend:7070/service_backend/;
    }

    location /api/thingaggregate/ {
      proxy_pass http://backend:7070/service_backend/;
    }

    location /api/actor/ {
      proxy_pass http://backend:7070/service_backend/;
    }

    location /api/storagefacility/ {
      proxy_pass http://backend:7070/service_backend/;
    }

    location /api/storagefacility/v1/ {
      proxy_pass http://backend:7070/service_backend/;
    }

    location /api/barcode/ {
      proxy_pass http://barcode:7070/service_barcode/;
    }

    location /service_barcode/ {
      proxy_pass http://barcode:7070/service_barcode/;
    }

    location /service_management/ {
      proxy_pass http://backend:7070/service_backend/;
    }

    location /api/management/ {
      proxy_pass http://backend:7070/service_backend/;
    }

    location /api/ {
      proxy_pass http://backend:7070/service_backend/;
    }

    # redirect server error pages to the static page /50x.html
    error_page   500 502 503 504  /50x.html;
    location = /50x.html {
      root   html;
    }
  }
}